tests/basic ensure that the directory is actually an absolute path, not a relative...
[monkeysphere.git] / tests / basic
index b9ae8f110146b37d0669f6afe7a57e78393a8d83..455c0578fb90d4a80f35fe79fe926ab9b307abcc 100755 (executable)
@@ -2,47 +2,95 @@
 
 # Tests to ensure that the monkeysphere is working
 
-# Author: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
-# Date: 2008-09-13 13:40:15-0400
+# Authors: 
+#   Daniel Kahn Gillmor <dkg@fifthhorseman.net>
+#   Jameson Rollins <jrollins@fifthhorseman.net>
+#   Micah Anderson <micah@riseup.net> 
+#
+# Copyright: 2008-2009
+# License: GPL v3 or later
 
-# these tests might be best run under fakeroot, particularly the
-# "server-side" tests.  Using fakeroot, they should be able to be run
-# as a non-privileged user.
+# these tests should all be able to run as a non-privileged user.
 
-# NOTE: these tests have *not* themselves been tested yet
-# (2008-09-13).  Please exercise with caution!
+# all subcommands in this script should complete without failure:
+set -e
+# piped commands should return the code of the first non-zero return
+set -o pipefail
 
-# these tests assume a commonly-trusted "Admin's key", a fake key
-# permanently stored in ./home/admin/.gnupg:
-gpgadmin() {
-    GNUPGHOME="$TESTDIR"/home/admin/.gnupg gpg "$@"
-}
+export TESTDIR=$(dirname "$0")
 
+source "$TESTDIR"/common
 
-# cleanup:
-cleanup() {
-    # FIXME: stop the sshd process
+## make sure that the right tools are installed to run the test.  the
+## test has *more* requirements than plain ol' monkeysphere:
+which socat >/dev/null || { echo "You must have socat installed to run this test." ; exit 1; }
 
-    echo
-    echo "-- removing temp dir..."
-    rm -rf "$TEMPDIR"
+## FIXME: other checks?
 
-    # FIXME: how should we clear out the temporary $VARLIB?
+######################################################################
+### FUNCTIONS
+
+# gpg command for test admin user
+gpgadmin() {
+    GNUPGHOME="$TEMPDIR"/admin/.gnupg gpg "$@"
+}
 
-    # FIXME: clear out ssh client config file and known hosts.
+# test ssh connection
+# first argument is expected return code from ssh connection
+ssh_test() {
+    umask 0077
+
+    CODE=${1:-0}
+
+    # start the ssh daemon on the socket
+    echo "##### starting ssh server..."
+    socat EXEC:"/usr/sbin/sshd -f ${SSHD_CONFIG} -i -D -e" "UNIX-LISTEN:${SOCKET}" 2> "$TEMPDIR"/sshd.log &
+    SSHD_PID="$!"
+
+    # wait until the socket is created before continuing
+    while [ ! -S "$SOCKET" ] ; do
+       sleep 1
+    done
+
+    set +e
+
+    # make a client connection to the socket
+    echo "##### starting ssh client..."
+    ssh-agent bash -c \
+       "monkeysphere subkey-to-ssh-agent && ssh -F $TEMPDIR/testuser/.ssh/config testhost true"
+    RETURN="$?"
+
+    # kill the sshd process if it's still running
+    kill "$SSHD_PID"
+    SSHD_PID=
+
+    set -e
+
+    echo "##### return $RETURN"
+    if [ "$RETURN" = "$CODE" ] ; then
+       echo "##### ssh connection test returned as desired"
+       return 0
+    else
+       echo "##### ssh connection test failed.  expected return code $CODE"
+       return 1
+    fi
 }
 
+SSHD_PID=
+
 ## setup trap
-#trap cleanup EXIT
+trap failed_cleanup EXIT
+
+
+######################################################################
+### SETUP VARIABLES
 
 ## set up some variables to ensure that we're operating strictly in
 ## the tests, not system-wide:
 
-export TESTDIR=$(pwd)
-
 # make temp dir
-TEMPDIR="$TESTDIR"/tmp
-mkdir "$TEMPDIR"
+mkdir -p "$TESTDIR"/tmp
+TEMPDIR=$(mktemp -d ${TMPDIR:-$(cd "$TESTDIR" && printf "%s" $(pwd)/tmp)}/monkeyspheretest.XXXXXXX)
 
 # Use the local copy of executables first, instead of system ones.
 # This should help us test without installing.
@@ -50,64 +98,202 @@ export PATH="$TESTDIR"/../src:"$TESTDIR"/../src/keytrans:"$PATH"
 
 export MONKEYSPHERE_SYSDATADIR="$TEMPDIR"
 export MONKEYSPHERE_SYSCONFIGDIR="$TEMPDIR"
-export MONKEYSPHERE_SYSSHAREDIR="$TESTDIR"/../src
-export MONKEYSPHERE_MONKEYSPHERE_USER="$USER"
-export SOCKET="$TEMPDIR"/ssh-socket
-
-### SERVER TESTS
-
-# create the temp gnupghome directories
-mkdir -p -m 750 "$MONKEYSPHERE_SYSDATADIR"/gnupg-host
-mkdir -p -m 700 "$MONKEYSPHERE_SYSDATADIR"/gnupg-authentication
-
-# create a new host key
-echo "-- generating server key..."
-echo | monkeysphere-server gen-key --length 1024 --expire 0
-
-HOSTKEYID=$( monkeysphere-server show-key | tail -n1 | cut -f3 -d\  )
+export MONKEYSPHERE_SYSSHAREDIR="$TESTDIR"/../src/share
+export MONKEYSPHERE_MONKEYSPHERE_USER=$(whoami)
+export MONKEYSPHERE_CHECK_KEYSERVER=false
+export MONKEYSPHERE_LOG_LEVEL=DEBUG
+export MONKEYSPHERE_CORE_KEYLENGTH=1024
 
-# certify it with the "Admin's Key".
-# (this would normally be done via keyservers)
-echo "-- certifying server key..."
-monkeysphere-server gpg-authentication-cmd "--armor --export $HOSTKEYID" | gpgadmin --import
-gpgadmin --sign-key "$HOSTKEYID"
-
-# FIXME: how can we test publish-key without flooding junk into the
-# keyservers?
-
-# indicate that the "Admin's" key is an identity certifier for the
-# host
+export SSHD_CONFIG="$TEMPDIR"/sshd_config
+export SOCKET="$TEMPDIR"/ssh-socket
 
-echo "-- adding admin as certifier..."
-monkeysphere-server add-identity-certifier "$TESTDIR"/home/admin/.gnupg/pubkey.gpg
+# Make sure $DISPLAY is set to convince ssh and monkeysphere to fall
+# back on $SSH_ASKPASS.  Make sure it's not set to the current actual
+# $DISPLAY (if one exists) because this test suite should not be doing
+# *anything* with any running X11 session.
+export DISPLAY=monkeys
+
+
+######################################################################
+### CONFIGURE ENVIRONMENTS
+
+# copy in admin and testuser home to tmp
+echo "##################################################"
+echo "### copying admin and testuser homes..."
+cp -a "$TESTDIR"/home/admin "$TEMPDIR"/
+cp -a "$TESTDIR"/home/testuser "$TEMPDIR"/
+
+# set up environment for testuser
+export TESTHOME="$TEMPDIR"/testuser
+export GNUPGHOME="$TESTHOME"/.gnupg
+chmod 0700 "$GNUPGHOME"
+export SSH_ASKPASS="$TESTHOME"/.ssh/askpass
+export MONKEYSPHERE_HOME="$TESTHOME"/.monkeysphere
+cat <<EOF >> "$TESTHOME"/.ssh/config
+UserKnownHostsFile $TESTHOME/.ssh/known_hosts
+IdentityFile $TESTHOME/.ssh/no-such-identity
+ProxyCommand $TESTHOME/.ssh/proxy-command %h %p $SOCKET
+EOF
+cat <<EOF >> "$MONKEYSPHERE_HOME"/monkeysphere.conf
+KNOWN_HOSTS=$TESTHOME/.ssh/known_hosts
+EOF
+get_gpg_prng_arg >> "$GNUPGHOME"/gpg.conf
 
+# set up sshd
+echo "##################################################"
+echo "### configuring sshd..."
+cp "$TESTDIR"/etc/ssh/sshd_config "$SSHD_CONFIG"
 # write the sshd_config
-cat <<EOF > "$TEMPDIR"/sshd_config
+cat <<EOF >> "$SSHD_CONFIG"
 HostKey ${MONKEYSPHERE_SYSDATADIR}/ssh_host_rsa_key
+AuthorizedKeysFile ${MONKEYSPHERE_SYSDATADIR}/authentication/authorized_keys/%u
 EOF
 
-# launch sshd with the new host key.
-echo "-- starting sshd..."
-socat EXEC:'/usr/sbin/sshd -f '"$TEMPDIR"/sshd_config' -i -d -d -d -D -e' "UNIX-LISTEN:${TEMPDIR/socket}" &
-
 
-### TESTUSER TESTS
+######################################################################
+### SERVER HOST SETUP
 
-# copy testuser home directory into temp dir
-cp -r "$TESTDIR"/home/testuser "$TEMPDIR"/
+# create a new host key
+echo "##################################################"
+echo "### testing host key generation..."
+mkdir -p -m 750 "$MONKEYSPHERE_SYSDATADIR"/host
+# add gpg.conf with quick-random
+get_gpg_prng_arg >> "$MONKEYSPHERE_SYSCONFIGDIR"/host/gpg.conf
+echo | monkeysphere-host expert gen-key --length 1024 testhost
+
+# remove the host home for the next test
+rm -rf "$MONKEYSPHERE_SYSCONFIGDIR"/host
+
+# import host key
+echo "##################################################"
+echo "### testing host key importing..."
+ssh-keygen -b 1024 -t rsa -N '' -f "$TEMPDIR"/ssh_host_rsa_key
+monkeysphere-host expert import-key testhost < "$TEMPDIR"/ssh_host_rsa_key
+
+# change host key expiration
+echo "##################################################"
+echo "### setting host key expiration..."
+monkeysphere-host set-expire 1
+monkeysphere-host show-key
+# FIXME: how do we check that the expiration has really been set?
+
+echo "##################################################"
+echo "### getting host key fingerprint..."
+HOSTKEYID=$( monkeysphere-host show-key | grep '^OpenPGP fingerprint: ' | cut -f3 -d\  )
+
+# certify host key with the "Admin's Key".
+# (this would normally be done via keyservers)
+echo "##################################################"
+echo "### certifying server host key..."
+GNUPGHOME="$MONKEYSPHERE_SYSCONFIGDIR"/host gpg --armor --export "$HOSTKEYID" | gpgadmin --import
+echo y | gpgadmin --command-fd 0 --sign-key "$HOSTKEYID"
 
-# generate an auth subkey for the test user
-echo "-- generating key for testuser..."
-MONKEYSPHERE_GNUPGHOME="$TEMPDIR"/testuser/.gnupg \
-    monkeysphere gen-subkey --expire 0
+# FIXME: add revoker?
 
-# connect to sample sshd host key, using monkeysphere to verify the
-# identity before connection.
+# FIXME: how can we test publish-key without flooding junk into the
+# keyservers?
 
-## FIXME: implement!
+# FIXME: should we run "diagnostics" here to test setup?
 
-# create a new client side key, certify it with the "CA", use it to
-# log in.
 
-## FIXME: implement!
+######################################################################
+### SERVER AUTHENTICATION SETUP
 
+# set up monkeysphere authentication
+echo "##################################################"
+echo "### setup monkeysphere authentication..."
+cp "$TESTDIR"/etc/monkeysphere/monkeysphere-authentication.conf "$TEMPDIR"/
+cat <<EOF >> "$TEMPDIR"/monkeysphere-authentication.conf
+AUTHORIZED_USER_IDS="$MONKEYSPHERE_HOME/authentication/authorized_user_ids"
+EOF
+monkeysphere-authentication setup
+get_gpg_prng_arg >> "$MONKEYSPHERE_SYSDATADIR"/authentication/sphere/gpg.conf
+
+# add admin as identity certifier for testhost
+echo "##################################################"
+echo "### adding admin as certifier..."
+echo y | monkeysphere-authentication add-id-certifier "$TEMPDIR"/admin/.gnupg/pubkey.gpg
+
+# FIXME: should we run "diagnostics" here to test setup?
+
+
+######################################################################
+### TESTUSER SETUP
+
+# generate an auth subkey for the test user that expires in 2 days
+echo "##################################################"
+echo "### generating key for testuser..."
+monkeysphere gen-subkey --expire 2
+
+# add server key to testuser keychain
+echo "##################################################"
+echo "### export server key to testuser..."
+gpgadmin --armor --export "$HOSTKEYID" | gpg --import
+
+# teach the "server" about the testuser's key
+echo "##################################################"
+echo "### export testuser key to server..."
+gpg --export testuser | monkeysphere-authentication expert gpg-cmd --import
+
+# update authorized_keys for user
+echo "##################################################"
+echo "### update server authorized_keys file for this testuser..."
+monkeysphere-authentication update-users $(whoami)
+
+
+######################################################################
+### TESTS
+
+# connect to test sshd, using monkeysphere-ssh-proxycommand to verify
+# the identity before connection.  This should work in both directions!
+echo "##################################################"
+echo "### ssh connection test for success..."
+ssh_test
+
+# remove the testuser's authorized_user_ids file, update, and make
+# sure that the ssh authentication FAILS
+echo "##################################################"
+echo "### removing testuser authorized_user_ids and updating..."
+mv "$TESTHOME"/.monkeysphere/authorized_user_ids{,.bak}
+monkeysphere-authentication update-users $(whoami)
+echo "##################################################"
+echo "### ssh connection test for server authentication denial..."
+ssh_test 255
+mv "$TESTHOME"/.monkeysphere/authorized_user_ids{.bak,}
+
+# put improper permissions on authorized_user_ids file, update, and
+# make sure ssh authentication FAILS
+echo "##################################################"
+echo "### setting group writability on authorized_user_ids and updating..."
+chmod g+w "$TESTHOME"/.monkeysphere/authorized_user_ids
+monkeysphere-authentication update-users $(whoami)
+echo "##################################################"
+echo "### ssh connection test for server authentication denial..."
+ssh_test 255
+chmod g-w "$TESTHOME"/.monkeysphere/authorized_user_ids
+echo "##################################################"
+echo "### setting other writability on authorized_user_ids and updating..."
+chmod o+w "$TESTHOME"/.monkeysphere/authorized_user_ids
+monkeysphere-authentication update-users $(whoami)
+echo "##################################################"
+echo "### ssh connection test for server authentication denial..."
+ssh_test 255
+chmod o-w "$TESTHOME"/.monkeysphere/authorized_user_ids
+
+# FIXME: addtest: remove admin as id-certifier and check ssh failure
+
+# FIXME: addtest: add hostname on host key
+# FIXME: addtest: revoke hostname on host key and check ssh failure
+
+# FIXME: addtest: revoke the host key and check ssh failure
+
+
+######################################################################
+
+trap - EXIT
+
+echo "##################################################"
+echo " Monkeysphere basic tests completed successfully!"
+echo "##################################################"
+
+cleanup